#include "CAnimationObject.h"
#include <pthread>

class CThread
{
   public:
      Thread();
      int Start(void * arg);
   protected:
      int Run(void * arg);
      static void * EntryPoint(void*);
      virtual void Setup();
      virtual void Execute(void*);
      void * Arg() const {return Arg_;}
      void Arg(void*){Arg_ = a;}
   private:
      THREADID ThreadId_;
      void * Arg_;

};

CThread::Thread() {}

int CThread::Start(void * arg)
{
   Arg(arg); // store user data
   int code = thread_create(CThread::EntryPoint, this, &ThreadId_);
   return code;
}

int CThread::Run(void * arg)
{
   Setup();
   Execute( arg );
}

/*static */
void * CThread::EntryPoint(void * pthis)
{
   CThread * pt = (Thread*)pthis;
   pthis->Run( Arg() );
}

virtual void CThread::Setup()
{
        // Do any setup here
}

virtual void CThread::Execute(void* arg)
{
	(CAnimationObject)arg->Compute();	
}